package guru.dead.icf320;

import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.stage.Stage;

import java.io.IOException;

public class MainApplication extends Application {

    private MainController controller;

    @Override
    public void start(Stage stage) throws IOException {
        FXMLLoader fxmlLoader = new FXMLLoader(MainApplication.class.getResource("home-view.fxml"));
        Parent root = fxmlLoader.load();
        controller = fxmlLoader.getController();
        controller.setStage(stage);

        Scene scene = new Scene(root, 725, 360);
        scene.getStylesheets().add(getClass().getResource("styles.css").toExternalForm());

        stage.getIcons().add(new Image(MainApplication.class.getResource("icon.png").toExternalForm()));
        stage.setTitle("ICOM IC-F320");
        stage.setScene(scene);
        stage.show();
    }

    @Override
    public void stop(){
        System.out.println("Stage is closing");
        controller.exitApplication();
    }

    public static void main(String[] args) {
        launch();
    }
}