package guru.dead.icf320;

import com.fazecast.jSerialComm.SerialPort;
import javafx.scene.control.TextArea;

import java.io.OutputStream;

public class SerialController {
    private OutputStream outputStream;
    private SerialPort selectedPort;

    private TextArea outputA;

    protected void sendData(String inputData) {
        try {
            if (selectedPort.isOpen()) {
                outputStream = selectedPort.getOutputStream();

                byte[] binaryData = hexStringToByteArray(inputData);

                outputStream.write(binaryData);

                log("DEBUG", "Data sent: " + binaryData.length + "\n");
            } else {
                log("ERROR", "Port closed =(\n");
            }
        } catch (Exception e) {
            e.printStackTrace();
            log("ERROR", "Error occurred: " + e.getMessage() + "\n");
        }
    }

    private byte[] hexStringToByteArray(String hexString) {
        int len = hexString.length();
        byte[] data = new byte[(len + 1) / 2];
        for (int i = 0, j = 0; i < len; i += 2, j++) {
            data[j] = (byte) ((Character.digit(hexString.charAt(i), 16) << 4)
                    + Character.digit(hexString.charAt(i + 1), 16));
        }
        return data;
    }

    public void log(String type, String message) {
        outputA.appendText("[" + type + "] " + message + "\n");
    }

    public void setOutputA(TextArea outputA) {
        this.outputA = outputA;
    }

    public void setSelectedPort(SerialPort selectedPort) {
        this.selectedPort = selectedPort;
    }
    public SerialPort getSelectedPort() {
        return selectedPort;
    }
}
